diff --git a/gcc/testsuite/c-c++-common/analyzer/paths-4.c b/gcc/testsuite/c-c++-common/analyzer/paths-4.c
index 60b3a0cfd2a..ceba7d7d0fd 100644
--- a/gcc/testsuite/c-c++-common/analyzer/paths-4.c
+++ b/gcc/testsuite/c-c++-common/analyzer/paths-4.c
@@ -32,22 +32,22 @@ int test_2 (struct state *s)
       switch (s->mode) /* { dg-message "if it ever follows 'default:' branch, it will always do so\.\.\." } */
 	{
 	case 0:
-	  __analyzer_dump_exploded_nodes (0); /* { dg-warning "2 processed enode" } */
+	  __analyzer_dump_exploded_nodes (0); /* { dg-warning "2 processed enodes" } */
 	  do_stuff (s, 0);
 	  break;
 	case 1:
-	  __analyzer_dump_exploded_nodes (0); /* { dg-warning "1 processed enode" } */
+	  __analyzer_dump_exploded_nodes (0); /* { dg-warning "2 processed enodes" } */
 	  do_stuff (s, 17);
 	  break;
 	case 2:
-	  __analyzer_dump_exploded_nodes (0); /* { dg-warning "1 processed enode" } */
+	  __analyzer_dump_exploded_nodes (0); /* { dg-warning "2 processed enodes" } */
 	  do_stuff (s, 5);
 	  break;
 	case 3:
-	  __analyzer_dump_exploded_nodes (0); /* { dg-warning "1 processed enode" } */
+	  __analyzer_dump_exploded_nodes (0); /* { dg-warning "2 processed enodes" } */
 	  return 42;
 	case 4:
-	  __analyzer_dump_exploded_nodes (0); /* { dg-warning "1 processed enode" } */
+	  __analyzer_dump_exploded_nodes (0); /* { dg-warning "2 processed enodes" } */
 	  return -3;
 	}
     }
diff --git a/gcc/testsuite/c-c++-common/analyzer/pr94362-1.c b/gcc/testsuite/c-c++-common/analyzer/pr94362-1.c
index a184636073f..22a23622191 100644
--- a/gcc/testsuite/c-c++-common/analyzer/pr94362-1.c
+++ b/gcc/testsuite/c-c++-common/analyzer/pr94362-1.c
@@ -1,6 +1,3 @@
-/* { dg-additional-options "-Wno-analyzer-too-complex" } */
-/* TODO: remove the need for -Wno-analyzer-too-complex.  */
-
 typedef struct evp_pkey_asn1_method_st EVP_PKEY_ASN1_METHOD;
 typedef struct engine_st ENGINE;
 struct stack_st_EVP_PKEY_ASN1_METHOD;
diff --git a/gcc/testsuite/c-c++-common/analyzer/pr94851-2.c b/gcc/testsuite/c-c++-common/analyzer/pr94851-2.c
index af838de9355..6a3e24afbc8 100644
--- a/gcc/testsuite/c-c++-common/analyzer/pr94851-2.c
+++ b/gcc/testsuite/c-c++-common/analyzer/pr94851-2.c
@@ -46,7 +46,7 @@ int pamark(void) {
     if (curbp->b_amark == (AMARK *)NULL)
       curbp->b_amark = p;
     else
-      last->m_next = p; /* { dg-warning "dereference of NULL 'last'" "deref" } */
+      last->m_next = p; /* { dg-warning "dereference of NULL 'last'" "deref" { xfail *-*-* } } */
   }
 
   p->m_name = (char)c; /* { dg-bogus "leak of 'p'" "bogus leak" } */
diff --git a/gcc/testsuite/c-c++-common/analyzer/pr96650-1-notrans.c b/gcc/testsuite/c-c++-common/analyzer/pr96650-1-notrans.c
index 94c755540b0..ef8a2ea6854 100644
--- a/gcc/testsuite/c-c++-common/analyzer/pr96650-1-notrans.c
+++ b/gcc/testsuite/c-c++-common/analyzer/pr96650-1-notrans.c
@@ -1,4 +1,5 @@
 /* { dg-additional-options "-O2 -fno-analyzer-transitivity" } */
+/* { dg-additional-options "-Wno-analyzer-too-complex" } */
 
 int *wf;
 
diff --git a/gcc/testsuite/c-c++-common/analyzer/pr98628.c b/gcc/testsuite/c-c++-common/analyzer/pr98628.c
index f339c495fd4..41c76c74d4c 100644
--- a/gcc/testsuite/c-c++-common/analyzer/pr98628.c
+++ b/gcc/testsuite/c-c++-common/analyzer/pr98628.c
@@ -1,4 +1,4 @@
-/* { dg-additional-options "-O1" } */
+/* { dg-additional-options "-O1 -Wno-analyzer-too-complex" } */
 
 void foo(void *);
 struct chanset_t {
diff --git a/gcc/testsuite/c-c++-common/analyzer/pr99774-1.c b/gcc/testsuite/c-c++-common/analyzer/pr99774-1.c
index 184baeef935..f95a37d71d1 100644
--- a/gcc/testsuite/c-c++-common/analyzer/pr99774-1.c
+++ b/gcc/testsuite/c-c++-common/analyzer/pr99774-1.c
@@ -2,7 +2,7 @@
    Reduced from
      https://git.qemu.org/?p=qemu.git;a=blob;f=subprojects/libvhost-user/libvhost-user.c;h=fab7ca17ee1fb27bcfc338527d1aeb9f923aade5;hb=HEAD#l1184
    which is licensed under GNU GPLv2 or later. */
-
+/* { dg-additional-options "-Wno-analyzer-too-complex" } */
 typedef unsigned char uint8_t;
 typedef unsigned short uint16_t;
 typedef unsigned long uint64_t;
diff --git a/gcc/testsuite/c-c++-common/analyzer/pragma-2.c b/gcc/testsuite/c-c++-common/analyzer/pragma-2.c
index f3098760fb0..6614d2e3075 100644
--- a/gcc/testsuite/c-c++-common/analyzer/pragma-2.c
+++ b/gcc/testsuite/c-c++-common/analyzer/pragma-2.c
@@ -48,7 +48,7 @@ void test (void)
 	  *pp = malloc (16); /* { dg-warning "leak" } */
 	  break;
 	case 1:
-	  free (*pp);
+	  free (*pp); /* { dg-warning "double-free" } */
 	  break;
 	case 2:
 	  /* no-op.  */
diff --git a/gcc/testsuite/c-c++-common/analyzer/realloc-1.c b/gcc/testsuite/c-c++-common/analyzer/realloc-1.c
index 0bb846c6249..f43d3412710 100644
--- a/gcc/testsuite/c-c++-common/analyzer/realloc-1.c
+++ b/gcc/testsuite/c-c++-common/analyzer/realloc-1.c
@@ -93,4 +93,4 @@ void test_10 (char *s, int n)
 {
   __builtin_realloc(s, n); /* { dg-warning "ignoring return value of '__builtin_realloc' declared with attribute 'warn_unused_result'" "" { target c } } */
   /* { dg-warning "ignoring return value of 'void\\* __builtin_realloc\\(void\\*, (long )*unsigned int\\)' declared with attribute 'warn_unused_result'" "" { target c++ } .-1 } */
-} /* { dg-warning "leak" } */
+} /* { dg-warning "leak" "" { target *-*-* } .-2 } */
diff --git a/gcc/testsuite/c-c++-common/analyzer/sock-1.c b/gcc/testsuite/c-c++-common/analyzer/sock-1.c
index 57938c0c0ab..d29d3a4da84 100644
--- a/gcc/testsuite/c-c++-common/analyzer/sock-1.c
+++ b/gcc/testsuite/c-c++-common/analyzer/sock-1.c
@@ -1,3 +1,4 @@
+/* { dg-additional-options "-fno-exceptions" } */
 typedef unsigned int __u32;
 __extension__ typedef __signed__ long long __s64;
 __extension__ typedef unsigned long long __u64;
diff --git a/gcc/testsuite/c-c++-common/analyzer/sprintf-2.c b/gcc/testsuite/c-c++-common/analyzer/sprintf-2.c
index 4e101306ae1..f89bdf8235f 100644
--- a/gcc/testsuite/c-c++-common/analyzer/sprintf-2.c
+++ b/gcc/testsuite/c-c++-common/analyzer/sprintf-2.c
@@ -3,7 +3,8 @@
 
 extern int
 sprintf(char* dst, const char* fmt, ...)
-  __attribute__((__nothrow__));
+  __attribute__((__nothrow__))
+  __attribute__((nonnull (1, 2)));
 
 #include "../../gcc.dg/analyzer/analyzer-decls.h"
 
diff --git a/gcc/testsuite/c-c++-common/analyzer/sprintf-concat.c b/gcc/testsuite/c-c++-common/analyzer/sprintf-concat.c
index ad744588bc0..decbec29e7d 100644
--- a/gcc/testsuite/c-c++-common/analyzer/sprintf-concat.c
+++ b/gcc/testsuite/c-c++-common/analyzer/sprintf-concat.c
@@ -31,5 +31,5 @@ test_2 (const char *a, const char *b)
   char *p = (char *) malloc (sz); /* { dg-message "allocated here" } */
   if (!p)
     return;
-  sprintf (p, "%s/%s", a, b); /* { dg-warning "leak of 'p' " } */
-}
+  sprintf (p, "%s/%s", a, b);
+} /* { dg-warning "leak of 'p' " } */
diff --git a/gcc/testsuite/c-c++-common/analyzer/stdarg-sentinel-1.c b/gcc/testsuite/c-c++-common/analyzer/stdarg-sentinel-1.c
index f8c1f0eb0f8..449e33ee22f 100644
--- a/gcc/testsuite/c-c++-common/analyzer/stdarg-sentinel-1.c
+++ b/gcc/testsuite/c-c++-common/analyzer/stdarg-sentinel-1.c
@@ -1,4 +1,4 @@
-/* { dg-additional-options "-Wno-analyzer-too-complex" } */
+/* { dg-additional-options "-fno-analyzer-call-summaries" } */
 
 #define NULL ((void *)0)
 
diff --git a/gcc/testsuite/c-c++-common/analyzer/strncpy-1.c b/gcc/testsuite/c-c++-common/analyzer/strncpy-1.c
index f8b38a58d4b..61f9712a038 100644
--- a/gcc/testsuite/c-c++-common/analyzer/strncpy-1.c
+++ b/gcc/testsuite/c-c++-common/analyzer/strncpy-1.c
@@ -7,7 +7,9 @@
 
 typedef __SIZE_TYPE__ size_t;
 
-extern char *strncpy (char *dst, const char *src, size_t count);
+extern char *
+strncpy (char *dst, const char *src, size_t count)
+  __attribute__ ((nonnull (1, 2)));
 
 char *
 test_passthrough (char *dst, const char *src, size_t count)
diff --git a/gcc/testsuite/c-c++-common/analyzer/strstr-1.c b/gcc/testsuite/c-c++-common/analyzer/strstr-1.c
index 469e6a817d0..a8edbd87e79 100644
--- a/gcc/testsuite/c-c++-common/analyzer/strstr-1.c
+++ b/gcc/testsuite/c-c++-common/analyzer/strstr-1.c
@@ -4,7 +4,9 @@
 
 #include "../../gcc.dg/analyzer/analyzer-decls.h"
 
-extern char *strstr (const char* str, const char* substr);
+extern char *
+strstr (const char* str, const char* substr)
+  __attribute__ ((nonnull));
 
 char *
 test_passthrough (const char* str, const char* substr)
diff --git a/gcc/testsuite/g++.dg/analyzer/analyzer.exp b/gcc/testsuite/g++.dg/analyzer/analyzer.exp
index 2e290bfc67f..a6f2f6ad7c9 100644
--- a/gcc/testsuite/g++.dg/analyzer/analyzer.exp
+++ b/gcc/testsuite/g++.dg/analyzer/analyzer.exp
@@ -29,7 +29,7 @@ if [info exists DEFAULT_CXXFLAGS] then {
 }
 
 # If a testcase doesn't have special options, use these.
-set DEFAULT_CXXFLAGS " -fanalyzer -Wanalyzer-too-complex -fanalyzer-call-summaries"
+set DEFAULT_CXXFLAGS " -fanalyzer -Wanalyzer-too-complex"
 
 # Initialize `dg'.
 dg-init
diff --git a/gcc/testsuite/g++.dg/analyzer/exception-value-2.C b/gcc/testsuite/g++.dg/analyzer/exception-value-2.C
index 5173f5381e8..1dac224f71b 100644
--- a/gcc/testsuite/g++.dg/analyzer/exception-value-2.C
+++ b/gcc/testsuite/g++.dg/analyzer/exception-value-2.C
@@ -1,4 +1,5 @@
 // { dg-skip-if "PR122044" { c++26 } { "*" } { "" } }
+// { dg-additional-options "-fno-analyzer-call-summaries" }
 
 #include "../../gcc.dg/analyzer/analyzer-decls.h"
 
diff --git a/gcc/testsuite/g++.dg/analyzer/fanalyzer-show-events-in-system-headers-default.C b/gcc/testsuite/g++.dg/analyzer/fanalyzer-show-events-in-system-headers-default.C
index d2381d0af3d..0a1acfc2fb8 100644
--- a/gcc/testsuite/g++.dg/analyzer/fanalyzer-show-events-in-system-headers-default.C
+++ b/gcc/testsuite/g++.dg/analyzer/fanalyzer-show-events-in-system-headers-default.C
@@ -16,5 +16,3 @@ int main () {
 
 /* { dg-note "\\(1\\) 'a\\.std::.+::_M_ptr' is NULL" "" { target c++14_down } declare_a } */
 /* { dg-note "dereference of NULL 'a\\.std::.+::operator->\\(\\)'" "" { target *-*-* } deref_a } */
-/* { dg-note "calling 'std::.+::operator->' from 'main'" "" { target *-*-* } deref_a } */
-/* { dg-note "returning to 'main' from 'std::.+::operator->'" "" { target *-*-* } deref_a } */
diff --git a/gcc/testsuite/g++.dg/analyzer/fanalyzer-show-events-in-system-headers-no.C b/gcc/testsuite/g++.dg/analyzer/fanalyzer-show-events-in-system-headers-no.C
index e143645074b..2fa99a37f81 100644
--- a/gcc/testsuite/g++.dg/analyzer/fanalyzer-show-events-in-system-headers-no.C
+++ b/gcc/testsuite/g++.dg/analyzer/fanalyzer-show-events-in-system-headers-no.C
@@ -17,5 +17,3 @@ int main () {
 
 /* { dg-note "\\(1\\) 'a\\.std::.+::_M_ptr' is NULL" "" { target c++14_down } declare_a } */
 /* { dg-note "dereference of NULL 'a\\.std::.+::operator->\\(\\)'" "" { target *-*-* } deref_a } */
-/* { dg-note "calling 'std::.+::operator->' from 'main'" "" { target *-*-* } deref_a } */
-/* { dg-note "returning to 'main' from 'std::.+::operator->'" "" { target *-*-* } deref_a } */
diff --git a/gcc/testsuite/g++.dg/analyzer/fanalyzer-show-events-in-system-headers.C b/gcc/testsuite/g++.dg/analyzer/fanalyzer-show-events-in-system-headers.C
index cc177e3d0bb..cb04fa00443 100644
--- a/gcc/testsuite/g++.dg/analyzer/fanalyzer-show-events-in-system-headers.C
+++ b/gcc/testsuite/g++.dg/analyzer/fanalyzer-show-events-in-system-headers.C
@@ -6,7 +6,7 @@
 
 struct A {int x; int y;};
 
-int main () { /* { dg-message "\\(1\\) entry to 'main'" "telltale event that we are going within a deeper frame than 'main'" } */
+int main () {
   std::shared_ptr<A> a;
   a->x = 4; /* { dg-line deref_a } */ 
   /* { dg-warning "dereference of NULL" "" { target *-*-* } deref_a } */
diff --git a/gcc/testsuite/g++.dg/analyzer/pr94028.C b/gcc/testsuite/g++.dg/analyzer/pr94028.C
index 53bfa2953ec..432eaec5d9d 100644
--- a/gcc/testsuite/g++.dg/analyzer/pr94028.C
+++ b/gcc/testsuite/g++.dg/analyzer/pr94028.C
@@ -30,12 +30,12 @@ j *
 f (B * b, int h, bool)
 {
   d (b->cls);
-  return new j (b, h); // { dg-warning "leak" }
+  return new j (b, h);
 }
 
 void
 m ()
 {
   if (i)
-    f (&k, 0, false);
+    f (&k, 0, false); // { dg-warning "leak" }
 }
diff --git a/gcc/testsuite/g++.dg/analyzer/pr96641.C b/gcc/testsuite/g++.dg/analyzer/pr96641.C
index eb11c8584b6..e4d8a8c3c17 100644
--- a/gcc/testsuite/g++.dg/analyzer/pr96641.C
+++ b/gcc/testsuite/g++.dg/analyzer/pr96641.C
@@ -7,7 +7,7 @@ struct iz : uh {
   virtual void
   sx ()
   {
-    sx ();
+    sx (); /* { dg-warning "infinite recursion" } */
   }
 };
 
diff --git a/gcc/testsuite/gcc.dg/analyzer/CWE-131-examples.c b/gcc/testsuite/gcc.dg/analyzer/CWE-131-examples.c
index 3bc898cd0cc..24b56ce5cd3 100644
--- a/gcc/testsuite/gcc.dg/analyzer/CWE-131-examples.c
+++ b/gcc/testsuite/gcc.dg/analyzer/CWE-131-examples.c
@@ -18,7 +18,7 @@
    ALL DOCUMENTS AND THE INFORMATION CONTAINED IN THE CWE ARE PROVIDED ON AN "AS IS" BASIS AND THE CONTRIBUTOR, THE ORGANIZATION HE/SHE REPRESENTS OR IS SPONSORED BY (IF ANY), THE MITRE CORPORATION, ITS BOARD OF TRUSTEES, OFFICERS, AGENTS, AND EMPLOYEES, DISCLAIM ALL WARRANTIES, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO ANY WARRANTY THAT THE USE OF THE INFORMATION THEREIN WILL NOT INFRINGE ANY RIGHTS OR ANY IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 
    IN NO EVENT SHALL THE CONTRIBUTOR, THE ORGANIZATION HE/SHE REPRESENTS OR IS SPONSORED BY (IF ANY), THE MITRE CORPORATION, ITS BOARD OF TRUSTEES, OFFICERS, AGENTS, AND EMPLOYEES BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE INFORMATION OR THE USE OR OTHER DEALINGS IN THE CWE.  */
-
+/* { dg-additional-options "-Wno-analyzer-too-complex" } */
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
diff --git a/gcc/testsuite/gcc.dg/analyzer/abs-1.c b/gcc/testsuite/gcc.dg/analyzer/abs-1.c
index d6ce8d6afad..d549136c9fc 100644
--- a/gcc/testsuite/gcc.dg/analyzer/abs-1.c
+++ b/gcc/testsuite/gcc.dg/analyzer/abs-1.c
@@ -15,7 +15,7 @@ hide_long (long x)
   return x;
 }
   
-long int test_2 (long int x)
+void test_2 (long int x)
 {
   __analyzer_eval (labs (hide_long (42)) == 42); /* { dg-warning "TRUE" } */
   __analyzer_eval (labs (hide_long (-17)) == 17); /* { dg-warning "TRUE" } */
diff --git a/gcc/testsuite/gcc.dg/analyzer/analyzer-decls.h b/gcc/testsuite/gcc.dg/analyzer/analyzer-decls.h
index db0140bee81..8d98fef69da 100644
--- a/gcc/testsuite/gcc.dg/analyzer/analyzer-decls.h
+++ b/gcc/testsuite/gcc.dg/analyzer/analyzer-decls.h
@@ -17,25 +17,37 @@
    None of these are actually implemented.  */
 
 /* Trigger a breakpoint in the analyzer when reached.  */
-extern void __analyzer_break (void);
+extern void
+__analyzer_break (void)
+  __attribute__ ((nothrow));
 
 /* Emit a warning describing the 2nd argument (which can be of any
    type), at the given verbosity level.  This is for use when
    debugging, and may be of use in DejaGnu tests.  */
-extern void __analyzer_describe (int verbosity, ...);
+extern void
+__analyzer_describe (int verbosity, ...)
+  __attribute__ ((nothrow));
 
 /* Dump copious information about the analyzer’s state when reached.  */
-extern void __analyzer_dump (void);
+extern void
+__analyzer_dump (void)
+  __attribute__ ((nothrow));
 
 /* Emit a warning describing the size of the base region of (*ptr).  */
-extern void __analyzer_dump_capacity (const void *ptr);
+extern void
+__analyzer_dump_capacity (const void *ptr)
+  __attribute__ ((nothrow));
 
 /* When reached, dump GraphViz .dot source to stderr for a diagram
    describing the analyzer’s state.  */
-extern void __analyzer_dump_dot (void);
+extern void
+__analyzer_dump_dot (void)
+  __attribute__ ((nothrow));
 
 /* Dump information about what decls have escaped at this point on the path.  */
-extern void __analyzer_dump_escaped (void);
+extern void
+__analyzer_dump_escaped (void)
+  __attribute__ ((nothrow));
 
 /* Dump information after analysis on all of the exploded nodes at this
    program point.
@@ -45,36 +57,54 @@ extern void __analyzer_dump_escaped (void);
 
    __analyzer_dump_exploded_nodes (1);
    will also dump all of the states within those nodes.  */
-extern void __analyzer_dump_exploded_nodes (int);
+extern void
+__analyzer_dump_exploded_nodes (int)
+  __attribute__ ((nothrow));
 
 /* Emit a warning describing what is known about the value of NAME.  */
-extern void __analyzer_dump_named_constant (const char *name);
+extern void
+__analyzer_dump_named_constant (const char *name)
+  __attribute__ ((nothrow));
 
 /* Emit a placeholder "note" diagnostic with a path to this call site,
    if the analyzer finds a feasible path to it.  */
-extern void __analyzer_dump_path (void);
+extern void
+__analyzer_dump_path (void)
+  __attribute__ ((nothrow));
 
 /* Dump the region_model's state to stderr.  */
-extern void __analyzer_dump_region_model (void);
+extern void
+__analyzer_dump_region_model (void)
+  __attribute__ ((nothrow));
 
 /* Emit a warning describing the state of the 2nd argument
    (which can be of any type) with respect to NAME.
    This is for use when debugging, and may be of use in DejaGnu tests.  */
-extern void __analyzer_dump_state (const char *name, ...);
+extern void
+__analyzer_dump_state (const char *name, ...)
+  __attribute__ ((nothrow));
 
 /* Dump copious information about the analyzer’s state when reached.  */
-extern void __analyzer_dump_xml (void);
+extern void
+__analyzer_dump_xml (void)
+  __attribute__ ((nothrow));
 
 /* Emit a warning with text "TRUE", FALSE" or "UNKNOWN" based on the
    truthfulness of the argument.  */
-extern void __analyzer_eval (int);
+extern void
+__analyzer_eval (int)
+  __attribute__ ((nothrow));
 
 /* Obtain an "unknown" void *.  */
-extern void *__analyzer_get_unknown_ptr (void);
+extern void *
+__analyzer_get_unknown_ptr (void)
+  __attribute__ ((nothrow));
 
 /* Complain if PTR doesn't point to a null-terminated string.
    TODO: eventually get the strlen of the buffer (without the
    optimizer touching it).  */
-extern __SIZE_TYPE__ __analyzer_get_strlen (const char *ptr);
+extern __SIZE_TYPE__
+__analyzer_get_strlen (const char *ptr)
+  __attribute__ ((nothrow));
 
 #endif /* #ifndef ANALYZER_DECLS_H.  */
diff --git a/gcc/testsuite/gcc.dg/analyzer/analyzer.exp b/gcc/testsuite/gcc.dg/analyzer/analyzer.exp
index c67dc95ba08..1757cd0f490 100644
--- a/gcc/testsuite/gcc.dg/analyzer/analyzer.exp
+++ b/gcc/testsuite/gcc.dg/analyzer/analyzer.exp
@@ -30,7 +30,7 @@ if [info exists DEFAULT_CFLAGS] then {
 }
 
 # If a testcase doesn't have special options, use these.
-set DEFAULT_CFLAGS "-fanalyzer -Wanalyzer-too-complex -Wanalyzer-symbol-too-complex -fanalyzer-call-summaries"
+set DEFAULT_CFLAGS "-fanalyzer -Wanalyzer-too-complex -Wanalyzer-symbol-too-complex"
 
 if { [istarget "*-*-darwin*" ] } {
   # On macOS, system headers redefine by default some macros (memcpy,
diff --git a/gcc/testsuite/gcc.dg/analyzer/boxed-malloc-1.c b/gcc/testsuite/gcc.dg/analyzer/boxed-malloc-1.c
index 949306203c0..393640e30a9 100644
--- a/gcc/testsuite/gcc.dg/analyzer/boxed-malloc-1.c
+++ b/gcc/testsuite/gcc.dg/analyzer/boxed-malloc-1.c
@@ -17,7 +17,7 @@ boxed_malloc (size_t sz)
   return result;
 }
 
-boxed_ptr
+void
 boxed_free (boxed_ptr ptr)
 {
   free (ptr.value);
@@ -287,14 +287,14 @@ void test_22 (void)
   free (ptr.value); /* { dg-warning "double-'free' of 'ptr.value'" } */ 
 }
 
-int test_24 (void)
+void test_24 (void)
 {
   boxed_ptr ptr;
   ptr.value = __builtin_alloca (sizeof (int)); /* { dg-message "region created on stack here" } */
   free (ptr.value); /* { dg-warning "'free' of 'ptr.value' which points to memory on the stack \\\[CWE-590\\\]" } */
 }
 
-int test_25 (void)
+void test_25 (void)
 {
   char tmp[100]; /* { dg-message "region created on stack here" } */
   boxed_ptr p;
@@ -304,7 +304,7 @@ int test_25 (void)
 
 char global_buffer[100]; /* { dg-message "region created here" } */
 
-int test_26 (void)
+void test_26 (void)
 {
   boxed_ptr p;
   p.value = global_buffer;
diff --git a/gcc/testsuite/gcc.dg/analyzer/call-summaries-2.c b/gcc/testsuite/gcc.dg/analyzer/call-summaries-2.c
index 48c4815f527..f309ab683fc 100644
--- a/gcc/testsuite/gcc.dg/analyzer/call-summaries-2.c
+++ b/gcc/testsuite/gcc.dg/analyzer/call-summaries-2.c
@@ -509,7 +509,7 @@ int consume_two_ints_from_va_list (__builtin_va_list ap)
   return i * j;
 }
 
-int test_consume_two_ints_from_va_list (__builtin_va_list ap1)
+void test_consume_two_ints_from_va_list (__builtin_va_list ap1)
 {
   int p1, p2;
   __builtin_va_list ap2;
diff --git a/gcc/testsuite/gcc.dg/analyzer/combined-conditionals-1.c b/gcc/testsuite/gcc.dg/analyzer/combined-conditionals-1.c
index caac2678bf3..1342e0ae837 100644
--- a/gcc/testsuite/gcc.dg/analyzer/combined-conditionals-1.c
+++ b/gcc/testsuite/gcc.dg/analyzer/combined-conditionals-1.c
@@ -48,7 +48,7 @@ void test_6 (void)
     __analyzer_dump_path (); /* { dg-message "\\(2\\) \\.\\.\\.to here" } */
 }
 
-int test_7 (void)
+void test_7 (void)
 {
   if (foo () ? bar () ? baz () : 0 : 0) /* { dg-message "\\(1\\) following 'true' branch\\.\\.\\." } */
     __analyzer_dump_path (); /* { dg-message "\\(2\\) \\.\\.\\.to here" } */    
diff --git a/gcc/testsuite/gcc.dg/analyzer/compound-assignment-2.c b/gcc/testsuite/gcc.dg/analyzer/compound-assignment-2.c
index ecca9aca83b..4b1f27854cc 100644
--- a/gcc/testsuite/gcc.dg/analyzer/compound-assignment-2.c
+++ b/gcc/testsuite/gcc.dg/analyzer/compound-assignment-2.c
@@ -22,3 +22,4 @@ test_2 (void)
   aw2.ptrs[1] = malloc (512);
 } /* { dg-warning "leak of 'aw2.ptrs.0.'" "leak of element 0" } */
 /* { dg-warning "leak of 'aw2.ptrs.1.'" "leak of element 1" { target *-*-* } .-1 } */
+/* { dg-warning "use of uninitialized value '<return-value>'" "missing return" { target *-*-* } .-2 } */
diff --git a/gcc/testsuite/gcc.dg/analyzer/compound-assignment-3.c b/gcc/testsuite/gcc.dg/analyzer/compound-assignment-3.c
index 49259262c4a..86e7c69ba6f 100644
--- a/gcc/testsuite/gcc.dg/analyzer/compound-assignment-3.c
+++ b/gcc/testsuite/gcc.dg/analyzer/compound-assignment-3.c
@@ -23,3 +23,4 @@ test_2 (void)
   struct union_wrapper uw2;
   uw2.u.ptr = malloc (1024);
 } /* { dg-warning "leak of 'uw2.u.ptr'" } */
+/* { dg-warning "use of uninitialized value '<return-value>'" "missing return" { target *-*-* } .-1 } */
diff --git a/gcc/testsuite/gcc.dg/analyzer/conditionals-3.c b/gcc/testsuite/gcc.dg/analyzer/conditionals-3.c
index f1c6c208405..c63db45531b 100644
--- a/gcc/testsuite/gcc.dg/analyzer/conditionals-3.c
+++ b/gcc/testsuite/gcc.dg/analyzer/conditionals-3.c
@@ -12,7 +12,7 @@ static void __analyzer_only_called_when_flag_b_true (int i)
   __analyzer_eval (i == 17); /* { dg-warning "TRUE" } */
 }
 
-int test_1 (int flag_a, int flag_b)
+void test_1 (int flag_a, int flag_b)
 {
   int i = 17;
 
diff --git a/gcc/testsuite/gcc.dg/analyzer/data-model-1.c b/gcc/testsuite/gcc.dg/analyzer/data-model-1.c
index e7a44d2e353..b7301616edd 100644
--- a/gcc/testsuite/gcc.dg/analyzer/data-model-1.c
+++ b/gcc/testsuite/gcc.dg/analyzer/data-model-1.c
@@ -178,7 +178,7 @@ struct coord
   long y;
 };
 
-int test_12d (struct coord c)
+void test_12d (struct coord c)
 {
   struct coord d;
   d = c;
@@ -848,7 +848,7 @@ int test_39 (void)
   return *ptr;
 }
 
-int test_40 (int flag)
+void test_40 (int flag)
 {
   int i;
   if (flag)
diff --git a/gcc/testsuite/gcc.dg/analyzer/data-model-15.c b/gcc/testsuite/gcc.dg/analyzer/data-model-15.c
index 12e84a12420..82f0f22ae5c 100644
--- a/gcc/testsuite/gcc.dg/analyzer/data-model-15.c
+++ b/gcc/testsuite/gcc.dg/analyzer/data-model-15.c
@@ -26,7 +26,7 @@ int test_2 (const struct coord *c1, const struct coord *c2, double r_squared)
   return (dx * dx) + (dy * dy) + (dz * dz) <= r_squared;
 }
 
-int test_3 (const struct coord *c1, const struct coord *c2, struct coord *out)
+void test_3 (const struct coord *c1, const struct coord *c2, struct coord *out)
 {
   out->x = c1->x + c2->x;
   out->y = c1->y + c2->y;
diff --git a/gcc/testsuite/gcc.dg/analyzer/data-model-17.c b/gcc/testsuite/gcc.dg/analyzer/data-model-17.c
index d50b84ab43a..556c53ac7ab 100644
--- a/gcc/testsuite/gcc.dg/analyzer/data-model-17.c
+++ b/gcc/testsuite/gcc.dg/analyzer/data-model-17.c
@@ -14,7 +14,7 @@ static const config table[2] = {
   { cb_2 }
 };
 
-int deflate (foo_t *s, int which)
+void deflate (foo_t *s, int which)
 {
   (*(table[which].func))(s);
 }
diff --git a/gcc/testsuite/gcc.dg/analyzer/data-model-20a.c b/gcc/testsuite/gcc.dg/analyzer/data-model-20a.c
index 767b9912ed9..790485d1790 100644
--- a/gcc/testsuite/gcc.dg/analyzer/data-model-20a.c
+++ b/gcc/testsuite/gcc.dg/analyzer/data-model-20a.c
@@ -17,7 +17,7 @@ test (int n) {
       for (; i >= 0; i--) {
 	free(arr[i]); /* { dg-bogus "double-'free'" } */
       }
-      free(arr); /* { dg-bogus "leak" "" { xfail *-*-* } } */
+      free(arr); /* { dg-bogus "leak" } */
       return NULL;
     }
   }
diff --git a/gcc/testsuite/gcc.dg/analyzer/data-model-7.c b/gcc/testsuite/gcc.dg/analyzer/data-model-7.c
index cb0b33e66c8..f84b79f5fd3 100644
--- a/gcc/testsuite/gcc.dg/analyzer/data-model-7.c
+++ b/gcc/testsuite/gcc.dg/analyzer/data-model-7.c
@@ -1,7 +1,7 @@
 /* { dg-additional-options "-fno-analyzer-state-merge" } */
 #include "analyzer-decls.h"
 
-int test_40 (int flag)
+void test_40 (int flag)
 {
   int i;
   if (flag)
diff --git a/gcc/testsuite/gcc.dg/analyzer/doom-d_main-IdentifyVersion.c b/gcc/testsuite/gcc.dg/analyzer/doom-d_main-IdentifyVersion.c
index 1605047c423..e55c378c7ec 100644
--- a/gcc/testsuite/gcc.dg/analyzer/doom-d_main-IdentifyVersion.c
+++ b/gcc/testsuite/gcc.dg/analyzer/doom-d_main-IdentifyVersion.c
@@ -147,13 +147,13 @@ IdentifyVersion(void)
     strcpy(basedefault,
            "devdata"
            "default.cfg");
-    return; /* { dg-warning "leak of 'doom2wad'" } */
-    /* { dg-warning "leak of 'doomuwad'"    "leak" { target *-*-* } .-1 } */
-    /* { dg-warning "leak of 'doomwad'"     "leak" { target *-*-* } .-2 } */
-    /* { dg-warning "leak of 'doom1wad'"    "leak" { target *-*-* } .-3 } */
-    /* { dg-warning "leak of 'plutoniawad'" "leak" { target *-*-* } .-4 } */
-    /* { dg-warning "leak of 'tntwad'"      "leak" { target *-*-* } .-5 } */
-    /* { dg-warning "leak of 'doom2fwad'"   "leak" { target *-*-* } .-6 } */
+    return; /* { dg-warning "leak of 'doom2wad'" "" { xfail *-*-* } } */
+    /* { dg-warning "leak of 'doomuwad'"    "leak" { xfail *-*-* } .-1 } */
+    /* { dg-warning "leak of 'doomwad'"     "leak" { xfail *-*-* } .-2 } */
+    /* { dg-warning "leak of 'doom1wad'"    "leak" { xfail *-*-* } .-3 } */
+    /* { dg-warning "leak of 'plutoniawad'" "leak" { xfail *-*-* } .-4 } */
+    /* { dg-warning "leak of 'tntwad'"      "leak" { xfail *-*-* } .-5 } */
+    /* { dg-warning "leak of 'doom2fwad'"   "leak" { xfail *-*-* } .-6 } */
   }
 
   if (M_CheckParm("-regdev")) {
@@ -170,13 +170,13 @@ IdentifyVersion(void)
     strcpy(basedefault,
            "devdata"
            "default.cfg");
-    return; /* { dg-warning "leak of 'doom2wad'" } */
-    /* { dg-warning "leak of 'doomuwad'"    "leak" { target *-*-* } .-1 } */
-    /* { dg-warning "leak of 'doomwad'"     "leak" { target *-*-* } .-2 } */
-    /* { dg-warning "leak of 'doom1wad'"    "leak" { target *-*-* } .-3 } */
-    /* { dg-warning "leak of 'plutoniawad'" "leak" { target *-*-* } .-4 } */
-    /* { dg-warning "leak of 'tntwad'"      "leak" { target *-*-* } .-5 } */
-    /* { dg-warning "leak of 'doom2fwad'"   "leak" { target *-*-* } .-6 } */
+    return; /* { dg-warning "leak of 'doom2wad'" "" { xfail *-*-* } } */
+    /* { dg-warning "leak of 'doomuwad'"    "leak" { xfail *-*-* } .-1 } */
+    /* { dg-warning "leak of 'doomwad'"     "leak" { xfail *-*-* } .-2 } */
+    /* { dg-warning "leak of 'doom1wad'"    "leak" { xfail *-*-* } .-3 } */
+    /* { dg-warning "leak of 'plutoniawad'" "leak" { xfail *-*-* } .-4 } */
+    /* { dg-warning "leak of 'tntwad'"      "leak" { xfail *-*-* } .-5 } */
+    /* { dg-warning "leak of 'doom2fwad'"   "leak" { xfail *-*-* } .-6 } */
   }
 
   if (M_CheckParm("-comdev")) {
@@ -193,13 +193,13 @@ IdentifyVersion(void)
     strcpy(basedefault,
            "devdata"
            "default.cfg");
-    return; /* { dg-warning "leak of 'doom2wad'" } */
-    /* { dg-warning "leak of 'doomuwad'"    "leak" { target *-*-* } .-1 } */
-    /* { dg-warning "leak of 'doomwad'"     "leak" { target *-*-* } .-2 } */
-    /* { dg-warning "leak of 'doom1wad'"    "leak" { target *-*-* } .-3 } */
-    /* { dg-warning "leak of 'plutoniawad'" "leak" { target *-*-* } .-4 } */
-    /* { dg-warning "leak of 'tntwad'"      "leak" { target *-*-* } .-5 } */
-    /* { dg-warning "leak of 'doom2fwad'"   "leak" { target *-*-* } .-6 } */
+    return; /* { dg-warning "leak of 'doom2wad'" "" { xfail *-*-* } } */
+    /* { dg-warning "leak of 'doomuwad'"    "leak" { xfail *-*-* } .-1 } */
+    /* { dg-warning "leak of 'doomwad'"     "leak" { xfail *-*-* } .-2 } */
+    /* { dg-warning "leak of 'doom1wad'"    "leak" { xfail *-*-* } .-3 } */
+    /* { dg-warning "leak of 'plutoniawad'" "leak" { xfail *-*-* } .-4 } */
+    /* { dg-warning "leak of 'tntwad'"      "leak" { xfail *-*-* } .-5 } */
+    /* { dg-warning "leak of 'doom2fwad'"   "leak" { xfail *-*-* } .-6 } */
   }
 
   if (!access(doom2fwad, 4)) {
diff --git a/gcc/testsuite/gcc.dg/analyzer/doom-s_sound-pr108867.c b/gcc/testsuite/gcc.dg/analyzer/doom-s_sound-pr108867.c
index ac0a789a7bb..61b8c908299 100644
--- a/gcc/testsuite/gcc.dg/analyzer/doom-s_sound-pr108867.c
+++ b/gcc/testsuite/gcc.dg/analyzer/doom-s_sound-pr108867.c
@@ -633,7 +633,7 @@ S_getChannel(void* origin, sfxinfo_t* sfxinfo)
   if (cnum == numChannels) {
 
     for (cnum = 0; cnum < numChannels; cnum++)
-      if (channels[cnum].sfxinfo->priority >= sfxinfo->priority) /* { dg-warning "dereference of NULL" } */
+      if (channels[cnum].sfxinfo->priority >= sfxinfo->priority) /* { dg-warning "dereference of NULL" "" { xfail *-*-* } } */
         break;
 
     if (cnum == numChannels) {
diff --git a/gcc/testsuite/gcc.dg/analyzer/edges-1.c b/gcc/testsuite/gcc.dg/analyzer/edges-1.c
index 644a2df8daf..4e34612941d 100644
--- a/gcc/testsuite/gcc.dg/analyzer/edges-1.c
+++ b/gcc/testsuite/gcc.dg/analyzer/edges-1.c
@@ -22,9 +22,8 @@ void test_1 (const char *path, int flag)
     bar ();
 
   if (flag) /* { dg-message "when 'flag == 0'" "branch event" } */
-    fclose (fp); /* { dg-bogus "leak" "warning at wrong location" { xfail *-*-* } .-1 } */
-} /* { dg-warning "leak of FILE 'fp'" "warning" { xfail *-*-* } } */
-// TODO(xfail): location of leak message ought to be on closing brace
+    fclose (fp);
+} /* { dg-warning "leak of FILE 'fp'" "warning" } */
 
 void test_2 (const char *path, int flag)
 {
